/* Copyright 2019 Ling Zhang

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License. */

Object.defineProperty(exports,"__esModule",{value:!0});var e,t=require("@agentframework/app"),r=require("@agentframework/web"),o=require("@agentframework/domain"),i=require("net"),n=require("protobufjs"),s=require("stream"),a=require("path"),d=require("fs"),p=require("querystring"),l=require("node-fetch"),c=(e=l)&&"object"==typeof e&&"default"in e?e.default:e,u=require("url"),y=require("@agentframework/data"),g=require("crypto");class IdentityCookieHelper{static get(e){const t=e.cookies.getAll(e.settings.WEB_DEVICE_COOKIE_KEY);if(t)return t[t.length-1]}static set(e,t){const r=e.settings.WEB_DEVICE_COOKIE_DOMAIN||e.hostname,o=e.settings.WEB_DEVICE_COOKIE_KEY,n={path:"/",httpOnly:!0,maxAge:e.settings.WEB_DEVICE_COOKIE_EXPIRES_IN_SECONDS,secure:!e.settings.DEBUG};if(i.isIP(r))e.res.cookies.add(o,t,Object.assign({domain:r},n));else{const i=r.split(".");1===i.length&&e.res.cookies.add(o,t,Object.assign({domain:r},n)),i.length>1&&e.res.cookies.add(o,t,Object.assign({domain:i.slice(-2).join(".")},n)),i.length>2&&e.res.cookies.add(o,t,Object.assign({domain:i.slice(-3).join(".")},n))}return t}}class IdentityHelper{static getIdentityId(e){return this.verify(IdentityCookieHelper.get(e))}static createIdentityId(e){const r=this.sign(t.Base62.fromBuffer((new t.ObjectId).id));return e.state.new_device_id=r,e.logger.update({new_device:1}),IdentityCookieHelper.set(e,r)}static createIdentityAddress(e){const t=e.ip;let r=((t&&t.indexOf(":"))>=0?"/ip6/":"/ip4/")+t;const o=e.getHeader("x-forwarded-port");return o&&(r+="/tcp/"+o),r}static crc(e){let r=0;for(let t=0;t<e.length;t++)r+=e.charCodeAt(t);return t.Base62.singleton.alphabet[r%62]}static sign(e){return this.crc(e)+e}static verify(e){if(!e)return e;const t=e.slice(1),r=this.crc(t);return e[0]===r?t:void 0}}class SHA512{static sign(e,o){const i=new r.Secret(e.settings.SECRET_KEYS,"sha512").sign(o);return t.Base62.fromBuffer(o)+"."+t.Base62.fromBuffer(i)}static verify(e,o){const i=o.indexOf(".");if(i>0&&i<o.length){const i=new r.Secret(e.settings.SECRET_KEYS,"sha512");try{const e=o.split("."),r=t.Base62.toBuffer(e[0]),n=t.Base62.toBuffer(e[1]);return!!i.verify(r,n)&&r}catch(e){return!1}}return!1}}class SessionCookieHelper{static get(e){const t=e.cookies.get(e.settings.WEB_SESSION_COOKIE_KEY);if(t&&t.length>40){const r=SHA512.verify(e,t);if(r)return r;e.logger.warn({id:e.ip,cookie:t},"[INTRUSION DETECTED] User sent invalidate auth token:")}return null}static set(e,t){const r={path:"/api",httpOnly:!0,secure:!e.settings.DEBUG};e.res.cookies.set(e.settings.WEB_SESSION_COOKIE_KEY,SHA512.sign(e,t),r)}static clear(e){const t={path:"/api",httpOnly:!0,maxAge:1,expires:new Date(2013,1,1),secure:!e.settings.DEBUG};e.res.cookies.set(e.settings.WEB_SESSION_COOKIE_KEY,"",t)}}class SessionProtocol{static get schema(){const e=n.Root.fromJSON({nested:{IdentityProfile:{fields:{_id:{type:"bytes",id:1},id:{type:"string",id:2},displayName:{type:"string",id:3},displayImageURL:{type:"string",id:4}}},WebSession:{fields:{session:{type:"string",id:1},user:{type:"string",id:2},token:{type:"string",id:3},roles:{type:"string",rule:"repeated",id:4},groups:{type:"string",rule:"repeated",id:5},scope:{type:"string",rule:"repeated",id:6},profile:{type:"IdentityProfile",id:7},timezone:{type:"string",id:8},locale:{type:"string",id:9},theme:{type:"string",id:10}}}}}).lookupType("WebSession");return Reflect.defineProperty(this,"schema",{value:e}),e}static encode(e){const t=Object.assign({},e);if(e.profile){const r=e.profile;t.profile={_id:r._id.id,id:r.id,displayName:r.displayName,displayImageURL:r.displayImageURL}}return this.schema.encode(t).finish()}static decode(e,r={}){let o;try{o=this.schema.decode(e)}catch(e){return null}for(const e of this.SessionFields)r[e]=o[e];if(o.profile){const e={};Object.assign(e,{_id:o.profile._id&&o.profile._id.byteLength?new t.ObjectId(o.profile._id):void 0,id:o.profile.id||void 0,displayName:o.profile.displayName,displayImageURL:o.profile.displayImageURL}),r.profile=e}return r}}SessionProtocol.SessionFields=["session","user","token","roles","groups","scope","profile","theme","timezone","locale"];class SessionHelper{static load(e,t){const r=SessionCookieHelper.get(e);r&&r.length&&SessionProtocol.decode(r,t)}static save(e,t){if(!t||!Object.keys(t).length)throw new r.ParameterError("Unable to update empty identity, please use WebIdentityService.clear() instead");const o=SessionProtocol.encode(t);if(!o||!o.byteLength)throw new r.AuthenticationError("Invalid session data (byteLength=0)");SessionCookieHelper.set(e,o)}static clear(e){SessionCookieHelper.clear(e)}}class WebFoundationRequestIdentity extends r.WebRequestIdentity{static[o.ClassInitializer](e,r){const o=new WebFoundationRequestIdentity;if(o.id=IdentityHelper.getIdentityId(e)||IdentityHelper.createIdentityId(e),o.address=IdentityHelper.createIdentityAddress(e),e.path.startsWith("/api")){const r={};SessionHelper.load(e,r),r&&r.session&&(t.IsExpiredObjectId(new t.ObjectId(r.token))?SessionHelper.clear(e):Object.assign(o,r))}return o.theme=o.theme||e.settings.THEME,o.locale=o.locale||e.settings.LOCALE,o.timezone=o.timezone||e.settings.TIMEZONE,o}}class WebFoundationApplicationIdentity extends r.WebApplicationIdentity{static[o.ClassInitializer](e){const t=new WebFoundationApplicationIdentity;return console.log("create app identity",e),t}}function h(e,r){return r().then(r=>{null!=r&&e.logger.warn({result:r},"Return value from middleware is been ignored"),e.req.performance.log("router","[[End]]");const o=e.logger,i=`[${e.ip}] ${e.status} ${e.method} ${e.path}`,n={},s=Date.now()-e.req.timestamp.getTime()>e.settings.LOG_SLOW_REQUEST_IN_MILLISECONDS;if(e.verbose||s){s&&(n.slow=1),n.headers=function(e){const t=e.toJSON(),r={};for(const[e,o]of Object.entries(t))o.length&&(r[e]=o.length>1?o:o[0]);return r}(e.req.headers);try{n.identity=e.identity}catch(e){n.identity={__xXx__:e.message}}Object.keys(e.params).length&&(n.params=e.params),Object.keys(e.query).length&&(n.query=e.query)}let a,{total:d,header:p}=e.req.performance.build(e.settings.NAME);e.res.headers.set("x-response-time",d.toFixed(4)),e.res.headers.append("server-timing",p),a=d>1e3?0:d>100?1:d>10?2:3,n.t=d.toFixed(a);const l=e.error;l?(l instanceof t.Exception&&(l.code&&(n.code=l.code),l.context&&(n.context=l.context)),o.error(l,n,i)):e.state.silent?o.trace(n,i):o.info(n,i)})}function f(e,o){return o().then(t=>{const o=e.res;r.MakeCookieHeaders(e),void 0===o.body&&(t instanceof s.Readable||Buffer.isBuffer(t)?o.body=t:o.body=function(e){return Array.isArray(e)?{ok:1,results:e}:void 0!==e?{ok:1,result:e}:{ok:1}}(t)),void 0===o.status&&(o.status=200)}).catch(o=>{r.MakeCookieHeaders(e),e.error=o;const{statusCode:i,statusMessage:n,headers:s,body:a}=function(e,o){let i,n,s=500,a="Server Exception";return o instanceof Error?o instanceof t.Exception?(o instanceof r.HttpError&&(o.headers&&(i=o.headers),o.statusCode&&(s=o.statusCode),o.statusMessage&&(a=o.statusMessage)),n=Object.assign({},o.toJSON(),{ok:0})):n={ok:0,error:o.name,message:o.message,stack:o.stack}:n={ok:0},{statusCode:s,statusMessage:a,headers:i,body:n}}(0,o);s&&e.res.setHeaders(s),null!=a&&(e.res.body=a),e.res.statusCode=i,e.res.statusMessage=n})}function m(e,t){const r=`REQ/${e.identity.id}/${e.req.timestamp.getTime()}`;e.req.logger.update({req_id:r}),e.setHeader("x-request-id",r),e.setHeader("x-request-count",String(e.req.id)),e.performance.log("router","[[LookupRoute]]");const o=e.req.app.router.search(e.method,e.path);return o&&(e.req.params=o.params,o.handler&&"function"==typeof o.handler)?o.handler(e):t()}function E(e,t){return"GET"===e.method?(e.status=404,e.body={ok:0,message:"Route Not Found"}):(e.status=405,e.body={ok:0,message:"Method Not Allowed"}),t()}let S;const v=new RegExp(/^text\/html/);function b(e,o,i={}){const n=a.normalize(a.resolve(i.root||e.settings.PUBLIC_DIR)),s="/"===(o=o||"/")[o.length-1];o=o.substr(a.parse(o).root.length);const p=i.index||"index.html",l=i.maxAge||e.settings.PUBLIC_DIR_CACHE_EXPIRES_IN_SECONDS;o=function(e){try{return decodeURIComponent(e)}catch(e){throw new t.Exception(e,"failed to decode")}}(o),s&&(o+=p);const c=function(e,t){if(-1!==t.indexOf("\0"))throw new r.MaliciousRequestError("NULL is not allowed in request path");if(S||(S=/(?:^|[\\\/])\.\.(?:[\\\/]|$)/),S.test(a.normalize("."+a.sep+t)))throw new r.MaliciousRequestError("Up path (../) is not allowed in request path");if(a.isAbsolute(t))throw new r.MaliciousRequestError("Absolute path is not allowed");return a.normalize(a.join(a.resolve(e),t))}(n,o);if(function(e,t){const r=t.substr(e.length).split(a.sep);if(".well-known"===r[0])return!1;for(let e=0;e<r.length;e++)if("."===r[e][0])return!0;return!1}(n,c))return!1;let u;try{if((u=d.statSync(c)).isDirectory())return!1}catch(e){if(~["ENOENT","ENAMETOOLONG","ENOTDIR"].indexOf(e.code))return!1;throw new r.ApplicationError(e,"Unable to access requested file")}e.logger.update({sz:(u.size/1024).toFixed(1)});const y=e.res;var g,h;return y.lastModified||(y.lastModified=u.mtime),y.status=200,y.length=u.size,y.type=(g=c,"."===(h=""!==(h="")?a.extname(a.basename(g,h)):a.extname(g))[0]?h.slice(1):h),y.hasHeader("x-content-type-options")||y.setHeader("x-content-type-options","nosniff"),l>0?y.hasHeader("cache-control")||y.setHeader("cache-control","public, max-age="+l):(y.hasHeader("pragma")||y.setHeader("pragma","no-cache"),y.hasHeader("cache-control")||y.setHeader("cache-control","no-cache, no-store, must-revalidate")),y.type.match(v)&&(e.settings.DEBUG||y.setHeader("strict-transport-security","max-age=31536000; includeSubDomains"),Array.isArray(e.settings.WEB_CONTENT_SECURITY_POLICY)&&y.setHeader("content-security-policy",e.settings.WEB_CONTENT_SECURITY_POLICY.join(" ")),y.setHeader("x-frame-options","SAMEORIGIN"),y.setHeader("x-xss-protection","1")),y.body=d.createReadStream(c),e.state.silent=!0,{file:c,type:y.type,length:u.size}}function I(e,t){if("GET"===e.method){e.performance.log("router","[[ServeStaticFile]]");try{b(e,e.path)||(e.status=404,e.body={ok:0,message:"File Not Found"})}catch(t){e.logger.error(t,"send file")}}else e.status=405,e.body={ok:0,message:"Method Not Allowed"};return t()}class MultipartWebForm extends r.WebForm{static[o.ClassInitializer](e,o){const i=new MultipartWebForm,n=e.type;if("multipart/form-data"===n){const o=String(e.headers.get("content-type"));if(Buffer.isBuffer(e.body)||"string"==typeof e.body)return function(e,o,i){return new Promise((n,s)=>{const a=new(require("busboy"))({headers:{"content-type":e}});a.on("file",(e,t,o,n,s)=>{const a=new r.FileField;a.name=e,a.originalname=o,a.mimetype=s,a.encoding=n;const d=[];t.on("data",e=>{d.push(e)}),t.on("end",()=>{a.data=Buffer.concat(d),i.push(a)})}),a.on("field",(e,t)=>{const o=new r.TextField;o.name=e,o.value=t,i.push(o)}),a.on("error",e=>s(new t.Exception(e,"Error parse form buffer"))),a.on("finish",()=>n(i)),a.write(o),a.end()})}(o,e.body,i);if(e.body instanceof s.Readable)return function(e,o,i){return new Promise((n,s)=>{const a=new(require("busboy"))({headers:{"content-type":e}});a.on("file",(e,t,o,n,s)=>{const a=new r.FileField;a.name=e,a.originalname=o,a.mimetype=s,a.encoding=n;const d=[];t.on("data",e=>{d.push(e)}),t.on("end",()=>{a.data=Buffer.concat(d),i.push(a)})}),a.on("field",(e,t)=>{const o=new r.TextField;o.name=e,o.value=t,i.push(o)}),a.on("error",e=>s(new t.Exception(e,"Error parse form buffer"))),a.on("finish",()=>n(i)),o.pipe(a)})}(o,e.body,i);throw new Error("Unknown body type for form: "+typeof e.body)}if("application/x-www-form-urlencoded"===n)return e.text().then(e=>{const t=p.parse(e),o=new r.WebForm;return Object.keys(t).map(e=>{const i=new r.TextField;return i.name=e,i.value=String(t[e]),o.push(i),i}),o});throw new Error(`Content-Type: ${e.type} is not a form`)}}class WebFoundationService extends t.Resolvable{}const w=/^https?:\/\//i;function _(e){return null!=e&&w.test(e)}class ExternalFetcher{constructor(e={}){if(this.defaults=e,e.baseURL&&!_(e.baseURL))throw new t.Exception({baseURL:e.baseURL},"Invalid fetch base url")}makeFetchOptions(e={}){const r=Object.assign({},this.defaults.query,e.query||{}),o=Object.assign({},this.defaults.headers,e.headers||{}),i=Object.assign({},e),n=i.headers=new l.Headers(o);let s;if(i.url&&_(i.url))s=new u.URL(i.url);else{if(!this.defaults.baseURL)throw new t.Exception({url:i.url},"Invalid fetch url");s=new u.URL(this.defaults.baseURL+i.url)}for(const e of Object.keys(r))s.searchParams.append(e,r[e]);if(i.data){const e=n.get("Content-Type");e&&e.toString().toLowerCase().startsWith("application/json")?i.body=JSON.stringify(i.data):e&&e.toString().toLowerCase().startsWith("application/x-www-form-urlencoded")?i.body=p.stringify(i.data):i.body=i.data,"string"==typeof i.body&&n.append("Content-Length",String(i.body.length))}return delete i.url,delete i.query,delete i.data,{url:s.toString(),init:i}}httpRequest(e){const{url:t,init:r}=this.makeFetchOptions(e);return c(t,r).then(async e=>{const t={url:e.url,status:e.status,statusText:e.statusText,headers:e.headers,type:e.headers.get("content-type")||"text/html"};return t.type.startsWith("application/json")?t.data=await e.json():t.type.startsWith("text/")?t.text=await e.text():t.body=e,t})}httpPost(e,t,r={}){return r.method="POST",r.url=e,r.data=t,this.httpRequest(r)}httpPut(e,t,r={}){return r.method="PUT",r.url=e,r.data=t,this.httpRequest(r)}httpGet(e,t={}){return t.method="GET",t.url=e,this.httpRequest(t)}httpGetAsText(e,t={}){return this.httpGet(e,t).then(e=>{if(!e.text)throw new Error("ResponseIsNotText");return e.text})}httpGetAsBuffer(e,t={}){return this.httpGet(e,t).then(e=>{if(!e.body)throw new Error("ResponseIsNotBuffer");return e.body.buffer()})}httpGetAsJson(e,t={}){return this.httpGet(e,t).then(e=>{if(!e.data)throw new Error("ResponseIsNotJSON");return e.data})}httpDelete(e,t={}){return t.method="DELETE",t.url=e,this.httpRequest(t)}}class OpenIdConnect extends ExternalFetcher{constructor(){super(...arguments),this.ConfigurationEndpoint="/.well-known/openid-configuration"}discovery(e){e.pathname=a.join(e.pathname,this.ConfigurationEndpoint);const t=e.toString();return super.httpGetAsJson(t)}static[o.ClassInitializer](e,t){return new OpenIdConnect}}function O(e,t,r,o){var i,n=arguments.length,s=n<3?t:null===o?o=Object.getOwnPropertyDescriptor(t,r):o;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,r,o);else for(var a=e.length-1;a>=0;a--)(i=e[a])&&(s=(n<3?i(s):n>3?i(t,r,s):i(t,r))||s);return n>3&&s&&Object.defineProperty(t,r,s),s}function x(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}let C=class ExternalProviderModel extends y.Model{static toJSON(e){return{provider:e.provider,providerProtocol:e.providerProtocol,providerURL:e.providerURL,providerFingerprint:e.providerFingerprint,providerConfiguration:JSON.stringify(e.providerConfiguration),appID:e.appID,appSecret:e.appSecret,scope:e.scope,displayName:e.displayName,displayImageURL:e.displayImageURL,description:e.description,createdAt:e.createdAt,createdFrom:e.createdFrom,createdBy:e.createdBy?JSON.stringify(e.createdBy):"{}",expireAt:e.expireAt,updatedAt:e.updatedAt,updatedFrom:e.updatedFrom,updatedBy:e.updatedBy?JSON.stringify(e.updatedBy):"{}"}}fromJSON(e){this.provider=e.provider,this.providerProtocol=e.providerProtocol,this.providerURL=e.providerURL,this.providerFingerprint=e.providerFingerprint,this.providerConfiguration=e.providerConfiguration?JSON.parse(e.providerConfiguration):{},this.appID=e.appID,this.appSecret=e.appSecret,this.scope=e.scope,this.displayName=e.displayName,this.displayImageURL=e.displayImageURL,this.description=e.description,this.createdAt=e.createdAt,this.createdFrom=e.createdFrom,this.createdBy=e.createdBy?JSON.parse(e.createdBy):{},this.expireAt=e.expireAt,this.updatedAt=e.updatedAt,this.updatedFrom=e.updatedFrom,this.updatedBy=e.updatedBy?JSON.parse(e.updatedBy):{}}};O([y.property(),x("design:type",String)],C.prototype,"provider",void 0),O([y.property(),x("design:type",String)],C.prototype,"providerProtocol",void 0),O([y.property(),x("design:type",String)],C.prototype,"providerURL",void 0),O([y.property(),x("design:type",String)],C.prototype,"providerFingerprint",void 0),O([y.property(),x("design:type",Object)],C.prototype,"providerConfiguration",void 0),O([y.property(),x("design:type",String)],C.prototype,"appID",void 0),O([y.property(),x("design:type",String)],C.prototype,"appSecret",void 0),O([y.property(),x("design:type",String)],C.prototype,"scope",void 0),O([y.property(),x("design:type",String)],C.prototype,"displayName",void 0),O([y.property(),x("design:type",String)],C.prototype,"displayImageURL",void 0),O([y.property(),x("design:type",String)],C.prototype,"description",void 0),C=O([y.model("external_provider")],C);class ExternalProviderCollection extends y.RecordCollection{constructor(){super(C)}}let R=class ExternalUserModel extends y.Model{};O([y.property(),x("design:type",Object)],R.prototype,"uid",void 0),O([y.property(),x("design:type",String)],R.prototype,"provider",void 0),O([y.property(),x("design:type",String)],R.prototype,"providerProtocol",void 0),O([y.property(),x("design:type",String)],R.prototype,"providerURL",void 0),O([y.property(),x("design:type",String)],R.prototype,"providerId",void 0),O([y.property(),x("design:type",String)],R.prototype,"providerData",void 0),O([y.property(),x("design:type",String)],R.prototype,"userData",void 0),O([y.property(),x("design:type",String)],R.prototype,"user",void 0),O([y.property(),x("design:type",String)],R.prototype,"username",void 0),O([y.property(),x("design:type",String)],R.prototype,"domain",void 0),O([y.property(),x("design:type",Object)],R.prototype,"email",void 0),O([y.property(),x("design:type",Boolean)],R.prototype,"emailCertified",void 0),O([y.property(),x("design:type",Object)],R.prototype,"mobile",void 0),O([y.property(),x("design:type",Boolean)],R.prototype,"mobileCertified",void 0),O([y.property(),x("design:type",String)],R.prototype,"displayName",void 0),O([y.property(),x("design:type",String)],R.prototype,"displayImageURL",void 0),O([y.property(),x("design:type",String)],R.prototype,"displayImageFile",void 0),O([y.property(),x("design:type",Object)],R.prototype,"familyName",void 0),O([y.property(),x("design:type",Object)],R.prototype,"givenName",void 0),O([y.property(),x("design:type",Object)],R.prototype,"gender",void 0),O([y.property(),x("design:type",Object)],R.prototype,"dob",void 0),O([y.property(),x("design:type",Object)],R.prototype,"status",void 0),O([y.property(),x("design:type",Object)],R.prototype,"bio",void 0),O([y.property(),x("design:type",Object)],R.prototype,"homepage",void 0),O([y.property(),x("design:type",Object)],R.prototype,"locale",void 0),R=O([y.model("external_user")],R);class ExternalUserCollection extends y.RecordCollection{constructor(){super(R)}}class WebFoundationController extends t.Resolvable{getFailureURL(e,t){return e.logger.error(t),"/#"+e.settings.WEB_SIGNIN_FAILED_PATH}}class BotService extends WebFoundationService{dispatch(e,t){console.log("dispatch",t)}}class Random{static generateRandomNumber(e){const t=Math.pow(10,e-1),r=Math.pow(10,e);return Math.floor(Math.random()*(r-t)+t)}static generateRandomToken(e){const t=[],r=this.POOL,o=this.MAX;for(let i=0;i<e;i++){const e=Math.floor(Math.random()*o);t.push(r[e])}return t.join("")}}Random.POOL="2346789BbCcDdFfGgHhJjKkMmPpQqRrTtVvWwXxYy",Random.MAX=Random.POOL.length;class MessageIdentity extends WebFoundationRequestIdentity{}class TelegramMessageIdentity extends MessageIdentity{static[o.ClassInitializer](e,[r]){let o=`${r.first_name}`;r.last_name&&(o+=` ${r.last_name}`);const i={uid:r.id,providerId:"3fdeba596a7d938a05c38daf"},n=t.CreateHashedObjectId(i).toHexString(),s=new TelegramMessageIdentity;return s.id=r.id,s.address=IdentityHelper.createIdentityAddress(e)+"/tg/"+r.id,s.user=n,s.profile={_id:n,id:r.username,displayName:o,displayImageURL:""},r.is_bot&&(s.profile.bot=r.is_bot),s.theme=s.theme||e.settings.THEME,s.locale=r.language_code||e.settings.LOCALE,s.timezone=s.timezone||e.settings.TIMEZONE,s}}exports.TelegramBotController=class TelegramBotController extends WebFoundationController{async telegram(e){if(!e.params.token)throw new r.ParameterError("Missing bot token for telegram");if(e.settings.TELEGRAM_BOT_TOKEN!=e.params.token)throw new r.ParameterError("Invalid bot token");const t=await e.json(),o=t.channelData||t,i=await e.resolve(TelegramMessageIdentity,function(e){const t=e.message||e.callback_query||e.edited_message||e.pre_checkout_query;let o;if(t)o=t.from;else{const t=Object.keys(e),i=t.find(t=>!!e[t].from);if(!i)throw new r.ParameterError(`Unable to find 'from' field in message: ${t}`);o=e[i].from}return[o,t,e]}(o));let n,s,a,d;if(o.message)s=(n=o.message).chat,d=n.text,a=new Date(1e3*n.date);else if(o.callback_query)s=(n=o.callback_query.message).chat,d=o.callback_query.data,a=new Date(1e3*n.date);else{if(!o.pre_checkout_query)return o.edited_message?(this.logger.debug({sourceEvent:o},"Edit message is ignored in this version"),void(e.body=null)):(this.logger.error({sourceEvent:o},"Unknown message type"),void(e.body=null));{const e=o.pre_checkout_query.from;s={id:e.id,first_name:e.first_name,last_name:e.last_name,username:e.username,type:"private"},d=o.pre_checkout_query.invoice_payload,a=new Date}}const p={id:Random.generateRandomToken(10),type:"message",identity:i,timestamp:a,from:{id:i.id,name:i.profile.displayName},conversation:{isGroup:"private"!==s.type,id:s.id},recipient:{id:e.settings.TELEGRAM_BOT_ID,name:e.settings.NAME},channelId:"telegram",channelData:o,text:d};this.bot.dispatch(e,p)}},O([o.singleton(),x("design:type",BotService)],exports.TelegramBotController.prototype,"bot",void 0),O([r.method("POST","/update/:token"),x("design:type",Function),x("design:paramtypes",[Object]),x("design:returntype",Promise)],exports.TelegramBotController.prototype,"telegram",null),exports.TelegramBotController=O([r.controller("/api/integration/telegram/bot")],exports.TelegramBotController);class SessionService extends WebFoundationService{async CreateSession(e,t){if(e.identity.session)throw new Error("SessionAlreadyExists");const r=SessionService.CreateNewSessionId(e),o=SessionService.CreateNewTokenId(e),i=Object.assign({},t,{session:r,token:o});return SessionHelper.save(e,i),Promise.resolve(i)}async ValidateSession(e){return!!(e.identity&&e.identity.token&&t.ObjectId.isValid(e.identity.token))&&!t.IsExpiredObjectId(new t.ObjectId(e.identity.token))}async UpdateSession(e,t,r){return e.identity.session===t&&(SessionHelper.save(e,Object.assign({},e.identity,r,{session:e.identity.session,token:SessionService.CreateNewTokenId(e)})),!0)}async ExtendSession(e,t){return this.UpdateSession(e,t,{})}async TerminateSession(e,t,r){if(e.identity.session===t){SessionHelper.clear(e);for(const t of Object.keys(e.identity))"id"!==t&&"address"!==t&&delete e.identity[t];return!0}return!1}static CreateNewSessionId(e){return(new t.ObjectId).toHexString()}static CreateNewTokenId(e){const r=new Date(Date.now()+e.settings.WEB_SESSION_EXPIRES_IN_MILLISECONDS);return new t.ObjectId(r).toHexString()}}let N=class FileModel extends y.Model{};O([y.property(),x("design:type",String)],N.prototype,"type",void 0),O([y.property(),x("design:type",Number)],N.prototype,"byteLength",void 0),O([y.property(),x("design:type",Buffer)],N.prototype,"data",void 0),O([y.property(),x("design:type",Buffer)],N.prototype,"md5",void 0),O([y.property(),x("design:type",Buffer)],N.prototype,"sha1",void 0),O([y.property(),x("design:type",Buffer)],N.prototype,"sha256",void 0),O([y.property(),x("design:type",String)],N.prototype,"ipfs",void 0),O([y.property(),x("design:type",Number)],N.prototype,"width",void 0),O([y.property(),x("design:type",Number)],N.prototype,"height",void 0),O([y.property(),x("design:type",Number)],N.prototype,"duration",void 0),N=O([y.model("file")],N);class FileCollection extends y.BlobCollection{constructor(){super(N)}}let B=class FileTokenModel extends y.Model{};O([y.property(),x("design:type",String)],B.prototype,"file",void 0),O([y.property(),x("design:type",String)],B.prototype,"type",void 0),O([y.property(),x("design:type",Number)],B.prototype,"byteLength",void 0),O([y.property(),x("design:type",String)],B.prototype,"title",void 0),O([y.property(),x("design:type",String)],B.prototype,"originalname",void 0),O([y.property(),x("design:type",String)],B.prototype,"originalurl",void 0),B=O([y.model("file_token")],B);class FileTokenCollection extends y.RecordCollection{constructor(){super(B)}}exports.BotService=BotService,exports.ExternalProviderService=class ExternalProviderService extends WebFoundationService{async findOrResolveExternalProvider(e,t){const r=this.createProviderId(t),o=await e.resolve(ExternalProviderCollection),i=await o.get(r);if(i){if(i.providerConfiguration)return i;if(i.providerConfiguration=await this.discoverProviderConfiguration(e,t.providerURL),!i.providerConfiguration)throw new Error("Unable to discover external id provider");return o.merge(r,i).then(e=>i)}if(t.providerConfiguration||(t.providerConfiguration=await this.discoverProviderConfiguration(e,t.providerURL)),!t.providerConfiguration)throw new Error("Unable to discover external id provider");return o.add(r,t).then(e=>{if(!e)throw new Error("Unable to create external provider");return e})}createProviderId(e){const r=[String(e.provider),String(e.providerProtocol),String(e.providerURL)];return e.appID&&r.push(String(e.appID)),t.CreateHashedObjectId(r)}async discoverProviderConfiguration(e,r){let o;try{o=new u.URL(r)}catch(e){throw new t.Exception(e,"Invalid external provider: "+r)}if("https:"!==o.protocol)throw new Error("Unsupported external id provider protocol: "+r);return e.construct(OpenIdConnect).discovery(o).catch(t=>(e.logger.warn(t,{issuer:o},"Unable to discover the configuration"),null))}},exports.ExternalUserService=class ExternalUserService extends WebFoundationService{async findOrCreateExternalUser(e,r){const o=await e.resolve(ExternalUserCollection),i=t.CreateHashedObjectId([r.uid,r.providerId]);let n=await o.get(i);return n||(n=new R,Object.assign(n,r),o.add(i,n).then(e=>{if(!e)throw new Error("Unable to create external user");return e}))}},exports.MultipartWebForm=MultipartWebForm,exports.RequestLogMiddleware=h,exports.RequestNormalizerMiddleware=f,exports.RequestNotFoundMiddleware=E,exports.RequestRouteMiddleware=m,exports.RequestStaticMiddleware=I,exports.SessionService=SessionService,exports.WebFileService=class WebFileService{async findTokenById(e,t){return(await e.resolve(FileTokenCollection)).get(t)}async findFileById(e,t){return(await e.resolve(FileCollection)).get(t)}async updateOne(e,t,r){return(await e.resolve(FileTokenCollection)).merge(t,{title:r.title})}async insertFromURL(e,t,r){const o=await function(e){return c(e).then(async e=>({data:await e.buffer(),dataType:e.headers.get("content-type")||"application/octet-stream",dataLength:parseInt(e.headers.get("content-length")||"0")}))}(t),i=t.split("/"),n=i[i.length-1];return this.insertFromBuffer(e,o.data,Object.assign({},r,{originalname:n,originalurl:t,type:o.dataType}))}async insertFromStream(e,t,o){const i=await r.StreamToBuffer(t);return this.insertFromBuffer(e,i,o)}async insertFromBuffer(e,r,o){let{type:i}=o;const n=g.createHash("sha256").update(r).digest(),s=require("multihashes").encode(n,"sha2-256"),a=t.Base58.fromBuffer(s),d=await e.resolve(FileCollection),p=await e.resolve(FileTokenCollection),l=await d.get(a),c=(new t.ObjectId).toString();if(l){i=l.type;const e={file:a,type:l.type,byteLength:l.byteLength};o&&(e.title=o.title,e.originalname=o.originalname,e.originalurl=o.originalurl),await p.add(c,e)}else{i=i||"application/octet-stream";const t=await e.resolve(FileCollection),n={type:i,byteLength:r.byteLength,data:r};if(o&&(n.width=o.width,n.height=o.height,n.duration=o.duration,n.ipfs=o.ipfs),!await t.add(a,n))throw new Error("UnableToSaveDataChunk");const s={file:a,type:i,byteLength:r.byteLength};o&&(s.title=o.title,s.originalname=o.originalname,s.originalurl=o.originalurl),await p.add(c,s)}return Object.assign({id:c,type:i,byteLength:r.byteLength,url:"/api/file/token/"+c},o)}},exports.WebFoundationApplication=class WebFoundationApplication extends r.WebApplication{invoke(e){return this.middleware.compose(e)}onInit(){this.addType(WebFoundationRequestIdentity),this.addType(WebFoundationApplicationIdentity),this.addType(MultipartWebForm),this.addMiddleware(h),this.addMiddleware(f),this.addMiddleware(m),this.onInitApplication(),this.settings.PUBLIC_DIR?(this.logger.warn(`Serving files from ${this.settings.PUBLIC_DIR}`),this.addMiddleware(I)):this.addMiddleware(E)}},exports.WebFoundationApplicationIdentity=WebFoundationApplicationIdentity,exports.WebFoundationRequestIdentity=WebFoundationRequestIdentity,exports.WebFoundationSettings=class WebFoundationSettings extends r.WebApplicationSettings{constructor(){super(...arguments),this.PUBLIC_DIR_CACHE_EXPIRES_IN_SECONDS=600,this.LOG_SLOW_REQUEST_IN_MILLISECONDS=1e4,this.WEB_DEVICE_COOKIE_KEY="__xXx__",this.WEB_DEVICE_COOKIE_EXPIRES_IN_SECONDS=3456e4,this.WEB_SESSION_COOKIE_KEY="__xXx__",this.WEB_SESSION_COOKIE_EXPIRES_IN_SECONDS=1800,this.WEB_SESSION_EXPIRES_IN_MILLISECONDS=18e5,this.WEB_CONTENT_SECURITY_POLICY=["script-src","'self'"],this.WEB_TOKEN_EXPIRES_IN_MILLISECONDS=3e5,this.WEB_SIGNIN_PATH="/authentication/signin",this.WEB_SIGNIN_SUCCESS_PATH="/authentication/validate",this.WEB_SIGNIN_FAILED_PATH="/authentication/failed",this.WEB_ACCESS_DENIED_PATH="/authentication/access_denied",this.WEB_SIGNOUT_PATH="/authentication/signout",this.WEB_SIGNOUT_COMPLETE_PATH="/",this.TRUSTED_EMAIL_PROVIDERS=[],this.THEME="default",this.OWNER_COMPANY_ADDRESS=[],this.OWNER_AGREEMENTS=[]}};
//# sourceMappingURL=index.js.map
