/* Copyright 2019 Ling Zhang

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License. */

import{Base62 as e,ObjectId as t,IsExpiredObjectId as r,Exception as i,Resolvable as o,CreateHashedObjectId as n,Base58 as s}from"@agentframework/app";import{Secret as a,ParameterError as d,AuthenticationError as p,WebRequestIdentity as c,WebApplicationIdentity as l,HttpError as u,MakeCookieHeaders as g,MaliciousRequestError as y,ApplicationError as h,FileField as f,TextField as m,WebForm as S,WebApplication as v,WebApplicationSettings as E,method as I,controller as b,StreamToBuffer as w}from"@agentframework/web";import{ClassInitializer as _,singleton as O}from"@agentframework/domain";import{isIP as C}from"net";import{Root as N}from"protobufjs";import{Readable as x}from"stream";import{normalize as R,join as L,resolve as k,sep as T,isAbsolute as B,parse as F,extname as U,basename as A}from"path";import{statSync as P,createReadStream as D}from"fs";import{parse as W,stringify as M}from"querystring";import H,{Headers as j}from"node-fetch";import{URL as q}from"url";import{property as G,model as K,Model as Y,RecordCollection as J,BlobCollection as X}from"@agentframework/data";import{createHash as $}from"crypto";class IdentityCookieHelper{static get(e){const t=e.cookies.getAll(e.settings.WEB_DEVICE_COOKIE_KEY);if(t)return t[t.length-1]}static set(e,t){const r=e.settings.WEB_DEVICE_COOKIE_DOMAIN||e.hostname,i=e.settings.WEB_DEVICE_COOKIE_KEY,o={path:"/",httpOnly:!0,maxAge:e.settings.WEB_DEVICE_COOKIE_EXPIRES_IN_SECONDS,secure:!e.settings.DEBUG};if(C(r))e.res.cookies.add(i,t,Object.assign({domain:r},o));else{const n=r.split(".");1===n.length&&e.res.cookies.add(i,t,Object.assign({domain:r},o)),n.length>1&&e.res.cookies.add(i,t,Object.assign({domain:n.slice(-2).join(".")},o)),n.length>2&&e.res.cookies.add(i,t,Object.assign({domain:n.slice(-3).join(".")},o))}return t}}class IdentityHelper{static getIdentityId(e){return this.verify(IdentityCookieHelper.get(e))}static createIdentityId(r){const i=this.sign(e.fromBuffer((new t).id));return r.state.new_device_id=i,r.logger.update({new_device:1}),IdentityCookieHelper.set(r,i)}static createIdentityAddress(e){const t=e.ip;let r=((t&&t.indexOf(":"))>=0?"/ip6/":"/ip4/")+t;const i=e.getHeader("x-forwarded-port");return i&&(r+="/tcp/"+i),r}static crc(t){let r=0;for(let e=0;e<t.length;e++)r+=t.charCodeAt(e);return e.singleton.alphabet[r%62]}static sign(e){return this.crc(e)+e}static verify(e){if(!e)return e;const t=e.slice(1),r=this.crc(t);return e[0]===r?t:void 0}}class SHA512{static sign(t,r){const i=new a(t.settings.SECRET_KEYS,"sha512").sign(r);return e.fromBuffer(r)+"."+e.fromBuffer(i)}static verify(t,r){const i=r.indexOf(".");if(i>0&&i<r.length){const i=new a(t.settings.SECRET_KEYS,"sha512");try{const t=r.split("."),o=e.toBuffer(t[0]),n=e.toBuffer(t[1]);return!!i.verify(o,n)&&o}catch(e){return!1}}return!1}}class SessionCookieHelper{static get(e){const t=e.cookies.get(e.settings.WEB_SESSION_COOKIE_KEY);if(t&&t.length>40){const r=SHA512.verify(e,t);if(r)return r;e.logger.warn({id:e.ip,cookie:t},"[INTRUSION DETECTED] User sent invalidate auth token:")}return null}static set(e,t){const r={path:"/api",httpOnly:!0,secure:!e.settings.DEBUG};e.res.cookies.set(e.settings.WEB_SESSION_COOKIE_KEY,SHA512.sign(e,t),r)}static clear(e){const t={path:"/api",httpOnly:!0,maxAge:1,expires:new Date(2013,1,1),secure:!e.settings.DEBUG};e.res.cookies.set(e.settings.WEB_SESSION_COOKIE_KEY,"",t)}}class SessionProtocol{static get schema(){const e=N.fromJSON({nested:{IdentityProfile:{fields:{_id:{type:"bytes",id:1},id:{type:"string",id:2},displayName:{type:"string",id:3},displayImageURL:{type:"string",id:4}}},WebSession:{fields:{session:{type:"string",id:1},user:{type:"string",id:2},token:{type:"string",id:3},roles:{type:"string",rule:"repeated",id:4},groups:{type:"string",rule:"repeated",id:5},scope:{type:"string",rule:"repeated",id:6},profile:{type:"IdentityProfile",id:7},timezone:{type:"string",id:8},locale:{type:"string",id:9},theme:{type:"string",id:10}}}}}).lookupType("WebSession");return Reflect.defineProperty(this,"schema",{value:e}),e}static encode(e){const t=Object.assign({},e);if(e.profile){const r=e.profile;t.profile={_id:r._id.id,id:r.id,displayName:r.displayName,displayImageURL:r.displayImageURL}}return this.schema.encode(t).finish()}static decode(e,r={}){let i;try{i=this.schema.decode(e)}catch(e){return null}for(const e of this.SessionFields)r[e]=i[e];if(i.profile){const e={};Object.assign(e,{_id:i.profile._id&&i.profile._id.byteLength?new t(i.profile._id):void 0,id:i.profile.id||void 0,displayName:i.profile.displayName,displayImageURL:i.profile.displayImageURL}),r.profile=e}return r}}SessionProtocol.SessionFields=["session","user","token","roles","groups","scope","profile","theme","timezone","locale"];class SessionHelper{static load(e,t){const r=SessionCookieHelper.get(e);r&&r.length&&SessionProtocol.decode(r,t)}static save(e,t){if(!t||!Object.keys(t).length)throw new d("Unable to update empty identity, please use WebIdentityService.clear() instead");const r=SessionProtocol.encode(t);if(!r||!r.byteLength)throw new p("Invalid session data (byteLength=0)");SessionCookieHelper.set(e,r)}static clear(e){SessionCookieHelper.clear(e)}}class WebFoundationRequestIdentity extends c{static[_](e,i){const o=new WebFoundationRequestIdentity;if(o.id=IdentityHelper.getIdentityId(e)||IdentityHelper.createIdentityId(e),o.address=IdentityHelper.createIdentityAddress(e),e.path.startsWith("/api")){const i={};SessionHelper.load(e,i),i&&i.session&&(r(new t(i.token))?SessionHelper.clear(e):Object.assign(o,i))}return o.theme=o.theme||e.settings.THEME,o.locale=o.locale||e.settings.LOCALE,o.timezone=o.timezone||e.settings.TIMEZONE,o}}class WebFoundationApplicationIdentity extends l{static[_](e){const t=new WebFoundationApplicationIdentity;return console.log("create app identity",e),t}}function z(e,t){return t().then(t=>{null!=t&&e.logger.warn({result:t},"Return value from middleware is been ignored"),e.req.performance.log("router","[[End]]");const r=e.logger,o=`[${e.ip}] ${e.status} ${e.method} ${e.path}`,n={},s=Date.now()-e.req.timestamp.getTime()>e.settings.LOG_SLOW_REQUEST_IN_MILLISECONDS;if(e.verbose||s){s&&(n.slow=1),n.headers=function(e){const t=e.toJSON(),r={};for(const[e,i]of Object.entries(t))i.length&&(r[e]=i.length>1?i:i[0]);return r}(e.req.headers);try{n.identity=e.identity}catch(e){n.identity={__xXx__:e.message}}Object.keys(e.params).length&&(n.params=e.params),Object.keys(e.query).length&&(n.query=e.query)}let a,{total:d,header:p}=e.req.performance.build(e.settings.NAME);e.res.headers.set("x-response-time",d.toFixed(4)),e.res.headers.append("server-timing",p),a=d>1e3?0:d>100?1:d>10?2:3,n.t=d.toFixed(a);const c=e.error;c?(c instanceof i&&(c.code&&(n.code=c.code),c.context&&(n.context=c.context)),r.error(c,n,o)):e.state.silent?r.trace(n,o):r.info(n,o)})}function V(e,t){return t().then(t=>{const r=e.res;g(e),void 0===r.body&&(t instanceof x||Buffer.isBuffer(t)?r.body=t:r.body=function(e){return Array.isArray(e)?{ok:1,results:e}:void 0!==e?{ok:1,result:e}:{ok:1}}(t)),void 0===r.status&&(r.status=200)}).catch(t=>{g(e),e.error=t;const{statusCode:r,statusMessage:o,headers:n,body:s}=function(e,t){let r,o,n=500,s="Server Exception";return t instanceof Error?t instanceof i?(t instanceof u&&(t.headers&&(r=t.headers),t.statusCode&&(n=t.statusCode),t.statusMessage&&(s=t.statusMessage)),o=Object.assign({},t.toJSON(),{ok:0})):o={ok:0,error:t.name,message:t.message,stack:t.stack}:o={ok:0},{statusCode:n,statusMessage:s,headers:r,body:o}}(0,t);n&&e.res.setHeaders(n),null!=s&&(e.res.body=s),e.res.statusCode=r,e.res.statusMessage=o})}function Q(e,t){const r=`REQ/${e.identity.id}/${e.req.timestamp.getTime()}`;e.req.logger.update({req_id:r}),e.setHeader("x-request-id",r),e.setHeader("x-request-count",String(e.req.id)),e.performance.log("router","[[LookupRoute]]");const i=e.req.app.router.search(e.method,e.path);return i&&(e.req.params=i.params,i.handler&&"function"==typeof i.handler)?i.handler(e):t()}function Z(e,t){return"GET"===e.method?(e.status=404,e.body={ok:0,message:"Route Not Found"}):(e.status=405,e.body={ok:0,message:"Method Not Allowed"}),t()}let ee;const te=new RegExp(/^text\/html/);function re(e,t,r={}){const o=R(k(r.root||e.settings.PUBLIC_DIR)),n="/"===(t=t||"/")[t.length-1];t=t.substr(F(t).root.length);const s=r.index||"index.html",a=r.maxAge||e.settings.PUBLIC_DIR_CACHE_EXPIRES_IN_SECONDS;t=function(e){try{return decodeURIComponent(e)}catch(e){throw new i(e,"failed to decode")}}(t),n&&(t+=s);const d=function(e,t){if(-1!==t.indexOf("\0"))throw new y("NULL is not allowed in request path");if(ee||(ee=/(?:^|[\\\/])\.\.(?:[\\\/]|$)/),ee.test(R("."+T+t)))throw new y("Up path (../) is not allowed in request path");if(B(t))throw new y("Absolute path is not allowed");return R(L(k(e),t))}(o,t);if(function(e,t){const r=t.substr(e.length).split(T);if(".well-known"===r[0])return!1;for(let e=0;e<r.length;e++)if("."===r[e][0])return!0;return!1}(o,d))return!1;let p;try{if((p=P(d)).isDirectory())return!1}catch(e){if(~["ENOENT","ENAMETOOLONG","ENOTDIR"].indexOf(e.code))return!1;throw new h(e,"Unable to access requested file")}e.logger.update({sz:(p.size/1024).toFixed(1)});const c=e.res;var l,u;return c.lastModified||(c.lastModified=p.mtime),c.status=200,c.length=p.size,c.type=(l=d,"."===(u=U(""!==(u="")?A(l,u):l))[0]?u.slice(1):u),c.hasHeader("x-content-type-options")||c.setHeader("x-content-type-options","nosniff"),a>0?c.hasHeader("cache-control")||c.setHeader("cache-control","public, max-age="+a):(c.hasHeader("pragma")||c.setHeader("pragma","no-cache"),c.hasHeader("cache-control")||c.setHeader("cache-control","no-cache, no-store, must-revalidate")),c.type.match(te)&&(e.settings.DEBUG||c.setHeader("strict-transport-security","max-age=31536000; includeSubDomains"),Array.isArray(e.settings.WEB_CONTENT_SECURITY_POLICY)&&c.setHeader("content-security-policy",e.settings.WEB_CONTENT_SECURITY_POLICY.join(" ")),c.setHeader("x-frame-options","SAMEORIGIN"),c.setHeader("x-xss-protection","1")),c.body=D(d),e.state.silent=!0,{file:d,type:c.type,length:p.size}}function ie(e,t){if("GET"===e.method){e.performance.log("router","[[ServeStaticFile]]");try{re(e,e.path)||(e.status=404,e.body={ok:0,message:"File Not Found"})}catch(t){e.logger.error(t,"send file")}}else e.status=405,e.body={ok:0,message:"Method Not Allowed"};return t()}class MultipartWebForm extends S{static[_](e,t){const r=new MultipartWebForm,o=e.type;if("multipart/form-data"===o){const t=String(e.headers.get("content-type"));if(Buffer.isBuffer(e.body)||"string"==typeof e.body)return function(e,t,r){return new Promise((o,n)=>{const s=new(require("busboy"))({headers:{"content-type":e}});s.on("file",(e,t,i,o,n)=>{const s=new f;s.name=e,s.originalname=i,s.mimetype=n,s.encoding=o;const a=[];t.on("data",e=>{a.push(e)}),t.on("end",()=>{s.data=Buffer.concat(a),r.push(s)})}),s.on("field",(e,t)=>{const i=new m;i.name=e,i.value=t,r.push(i)}),s.on("error",e=>n(new i(e,"Error parse form buffer"))),s.on("finish",()=>o(r)),s.write(t),s.end()})}(t,e.body,r);if(e.body instanceof x)return function(e,t,r){return new Promise((o,n)=>{const s=new(require("busboy"))({headers:{"content-type":e}});s.on("file",(e,t,i,o,n)=>{const s=new f;s.name=e,s.originalname=i,s.mimetype=n,s.encoding=o;const a=[];t.on("data",e=>{a.push(e)}),t.on("end",()=>{s.data=Buffer.concat(a),r.push(s)})}),s.on("field",(e,t)=>{const i=new m;i.name=e,i.value=t,r.push(i)}),s.on("error",e=>n(new i(e,"Error parse form buffer"))),s.on("finish",()=>o(r)),t.pipe(s)})}(t,e.body,r);throw new Error("Unknown body type for form: "+typeof e.body)}if("application/x-www-form-urlencoded"===o)return e.text().then(e=>{const t=W(e),r=new S;return Object.keys(t).map(e=>{const i=new m;return i.name=e,i.value=String(t[e]),r.push(i),i}),r});throw new Error(`Content-Type: ${e.type} is not a form`)}}class WebFoundationApplication extends v{invoke(e){return this.middleware.compose(e)}onInit(){this.addType(WebFoundationRequestIdentity),this.addType(WebFoundationApplicationIdentity),this.addType(MultipartWebForm),this.addMiddleware(z),this.addMiddleware(V),this.addMiddleware(Q),this.onInitApplication(),this.settings.PUBLIC_DIR?(this.logger.warn(`Serving files from ${this.settings.PUBLIC_DIR}`),this.addMiddleware(ie)):this.addMiddleware(Z)}}class WebFoundationSettings extends E{constructor(){super(...arguments),this.PUBLIC_DIR_CACHE_EXPIRES_IN_SECONDS=600,this.LOG_SLOW_REQUEST_IN_MILLISECONDS=1e4,this.WEB_DEVICE_COOKIE_KEY="__xXx__",this.WEB_DEVICE_COOKIE_EXPIRES_IN_SECONDS=3456e4,this.WEB_SESSION_COOKIE_KEY="__xXx__",this.WEB_SESSION_COOKIE_EXPIRES_IN_SECONDS=1800,this.WEB_SESSION_EXPIRES_IN_MILLISECONDS=18e5,this.WEB_CONTENT_SECURITY_POLICY=["script-src","'self'"],this.WEB_TOKEN_EXPIRES_IN_MILLISECONDS=3e5,this.WEB_SIGNIN_PATH="/authentication/signin",this.WEB_SIGNIN_SUCCESS_PATH="/authentication/validate",this.WEB_SIGNIN_FAILED_PATH="/authentication/failed",this.WEB_ACCESS_DENIED_PATH="/authentication/access_denied",this.WEB_SIGNOUT_PATH="/authentication/signout",this.WEB_SIGNOUT_COMPLETE_PATH="/",this.TRUSTED_EMAIL_PROVIDERS=[],this.THEME="default",this.OWNER_COMPANY_ADDRESS=[],this.OWNER_AGREEMENTS=[]}}class WebFoundationService extends o{}const oe=/^https?:\/\//i;function ne(e){return null!=e&&oe.test(e)}class ExternalFetcher{constructor(e={}){if(this.defaults=e,e.baseURL&&!ne(e.baseURL))throw new i({baseURL:e.baseURL},"Invalid fetch base url")}makeFetchOptions(e={}){const t=Object.assign({},this.defaults.query,e.query||{}),r=Object.assign({},this.defaults.headers,e.headers||{}),o=Object.assign({},e),n=o.headers=new j(r);let s;if(o.url&&ne(o.url))s=new q(o.url);else{if(!this.defaults.baseURL)throw new i({url:o.url},"Invalid fetch url");s=new q(this.defaults.baseURL+o.url)}for(const e of Object.keys(t))s.searchParams.append(e,t[e]);if(o.data){const e=n.get("Content-Type");e&&e.toString().toLowerCase().startsWith("application/json")?o.body=JSON.stringify(o.data):e&&e.toString().toLowerCase().startsWith("application/x-www-form-urlencoded")?o.body=M(o.data):o.body=o.data,"string"==typeof o.body&&n.append("Content-Length",String(o.body.length))}return delete o.url,delete o.query,delete o.data,{url:s.toString(),init:o}}httpRequest(e){const{url:t,init:r}=this.makeFetchOptions(e);return H(t,r).then(async e=>{const t={url:e.url,status:e.status,statusText:e.statusText,headers:e.headers,type:e.headers.get("content-type")||"text/html"};return t.type.startsWith("application/json")?t.data=await e.json():t.type.startsWith("text/")?t.text=await e.text():t.body=e,t})}httpPost(e,t,r={}){return r.method="POST",r.url=e,r.data=t,this.httpRequest(r)}httpPut(e,t,r={}){return r.method="PUT",r.url=e,r.data=t,this.httpRequest(r)}httpGet(e,t={}){return t.method="GET",t.url=e,this.httpRequest(t)}httpGetAsText(e,t={}){return this.httpGet(e,t).then(e=>{if(!e.text)throw new Error("ResponseIsNotText");return e.text})}httpGetAsBuffer(e,t={}){return this.httpGet(e,t).then(e=>{if(!e.body)throw new Error("ResponseIsNotBuffer");return e.body.buffer()})}httpGetAsJson(e,t={}){return this.httpGet(e,t).then(e=>{if(!e.data)throw new Error("ResponseIsNotJSON");return e.data})}httpDelete(e,t={}){return t.method="DELETE",t.url=e,this.httpRequest(t)}}class OpenIdConnect extends ExternalFetcher{constructor(){super(...arguments),this.ConfigurationEndpoint="/.well-known/openid-configuration"}discovery(e){e.pathname=L(e.pathname,this.ConfigurationEndpoint);const t=e.toString();return super.httpGetAsJson(t)}static[_](e,t){return new OpenIdConnect}}function se(e,t,r,i){var o,n=arguments.length,s=n<3?t:null===i?i=Object.getOwnPropertyDescriptor(t,r):i;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,r,i);else for(var a=e.length-1;a>=0;a--)(o=e[a])&&(s=(n<3?o(s):n>3?o(t,r,s):o(t,r))||s);return n>3&&s&&Object.defineProperty(t,r,s),s}function ae(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}let de=class ExternalProviderModel extends Y{static toJSON(e){return{provider:e.provider,providerProtocol:e.providerProtocol,providerURL:e.providerURL,providerFingerprint:e.providerFingerprint,providerConfiguration:JSON.stringify(e.providerConfiguration),appID:e.appID,appSecret:e.appSecret,scope:e.scope,displayName:e.displayName,displayImageURL:e.displayImageURL,description:e.description,createdAt:e.createdAt,createdFrom:e.createdFrom,createdBy:e.createdBy?JSON.stringify(e.createdBy):"{}",expireAt:e.expireAt,updatedAt:e.updatedAt,updatedFrom:e.updatedFrom,updatedBy:e.updatedBy?JSON.stringify(e.updatedBy):"{}"}}fromJSON(e){this.provider=e.provider,this.providerProtocol=e.providerProtocol,this.providerURL=e.providerURL,this.providerFingerprint=e.providerFingerprint,this.providerConfiguration=e.providerConfiguration?JSON.parse(e.providerConfiguration):{},this.appID=e.appID,this.appSecret=e.appSecret,this.scope=e.scope,this.displayName=e.displayName,this.displayImageURL=e.displayImageURL,this.description=e.description,this.createdAt=e.createdAt,this.createdFrom=e.createdFrom,this.createdBy=e.createdBy?JSON.parse(e.createdBy):{},this.expireAt=e.expireAt,this.updatedAt=e.updatedAt,this.updatedFrom=e.updatedFrom,this.updatedBy=e.updatedBy?JSON.parse(e.updatedBy):{}}};se([G(),ae("design:type",String)],de.prototype,"provider",void 0),se([G(),ae("design:type",String)],de.prototype,"providerProtocol",void 0),se([G(),ae("design:type",String)],de.prototype,"providerURL",void 0),se([G(),ae("design:type",String)],de.prototype,"providerFingerprint",void 0),se([G(),ae("design:type",Object)],de.prototype,"providerConfiguration",void 0),se([G(),ae("design:type",String)],de.prototype,"appID",void 0),se([G(),ae("design:type",String)],de.prototype,"appSecret",void 0),se([G(),ae("design:type",String)],de.prototype,"scope",void 0),se([G(),ae("design:type",String)],de.prototype,"displayName",void 0),se([G(),ae("design:type",String)],de.prototype,"displayImageURL",void 0),se([G(),ae("design:type",String)],de.prototype,"description",void 0),de=se([K("external_provider")],de);class ExternalProviderCollection extends J{constructor(){super(de)}}class ExternalProviderService extends WebFoundationService{async findOrResolveExternalProvider(e,t){const r=this.createProviderId(t),i=await e.resolve(ExternalProviderCollection),o=await i.get(r);if(o){if(o.providerConfiguration)return o;if(o.providerConfiguration=await this.discoverProviderConfiguration(e,t.providerURL),!o.providerConfiguration)throw new Error("Unable to discover external id provider");return i.merge(r,o).then(e=>o)}if(t.providerConfiguration||(t.providerConfiguration=await this.discoverProviderConfiguration(e,t.providerURL)),!t.providerConfiguration)throw new Error("Unable to discover external id provider");return i.add(r,t).then(e=>{if(!e)throw new Error("Unable to create external provider");return e})}createProviderId(e){const t=[String(e.provider),String(e.providerProtocol),String(e.providerURL)];return e.appID&&t.push(String(e.appID)),n(t)}async discoverProviderConfiguration(e,t){let r;try{r=new q(t)}catch(e){throw new i(e,"Invalid external provider: "+t)}if("https:"!==r.protocol)throw new Error("Unsupported external id provider protocol: "+t);return e.construct(OpenIdConnect).discovery(r).catch(t=>(e.logger.warn(t,{issuer:r},"Unable to discover the configuration"),null))}}let pe=class ExternalUserModel extends Y{};se([G(),ae("design:type",Object)],pe.prototype,"uid",void 0),se([G(),ae("design:type",String)],pe.prototype,"provider",void 0),se([G(),ae("design:type",String)],pe.prototype,"providerProtocol",void 0),se([G(),ae("design:type",String)],pe.prototype,"providerURL",void 0),se([G(),ae("design:type",String)],pe.prototype,"providerId",void 0),se([G(),ae("design:type",String)],pe.prototype,"providerData",void 0),se([G(),ae("design:type",String)],pe.prototype,"userData",void 0),se([G(),ae("design:type",String)],pe.prototype,"user",void 0),se([G(),ae("design:type",String)],pe.prototype,"username",void 0),se([G(),ae("design:type",String)],pe.prototype,"domain",void 0),se([G(),ae("design:type",Object)],pe.prototype,"email",void 0),se([G(),ae("design:type",Boolean)],pe.prototype,"emailCertified",void 0),se([G(),ae("design:type",Object)],pe.prototype,"mobile",void 0),se([G(),ae("design:type",Boolean)],pe.prototype,"mobileCertified",void 0),se([G(),ae("design:type",String)],pe.prototype,"displayName",void 0),se([G(),ae("design:type",String)],pe.prototype,"displayImageURL",void 0),se([G(),ae("design:type",String)],pe.prototype,"displayImageFile",void 0),se([G(),ae("design:type",Object)],pe.prototype,"familyName",void 0),se([G(),ae("design:type",Object)],pe.prototype,"givenName",void 0),se([G(),ae("design:type",Object)],pe.prototype,"gender",void 0),se([G(),ae("design:type",Object)],pe.prototype,"dob",void 0),se([G(),ae("design:type",Object)],pe.prototype,"status",void 0),se([G(),ae("design:type",Object)],pe.prototype,"bio",void 0),se([G(),ae("design:type",Object)],pe.prototype,"homepage",void 0),se([G(),ae("design:type",Object)],pe.prototype,"locale",void 0),pe=se([K("external_user")],pe);class ExternalUserCollection extends J{constructor(){super(pe)}}class ExternalUserService extends WebFoundationService{async findOrCreateExternalUser(e,t){const r=await e.resolve(ExternalUserCollection),i=n([t.uid,t.providerId]);let o=await r.get(i);return o||(o=new pe,Object.assign(o,t),r.add(i,o).then(e=>{if(!e)throw new Error("Unable to create external user");return e}))}}class WebFoundationController extends o{getFailureURL(e,t){return e.logger.error(t),"/#"+e.settings.WEB_SIGNIN_FAILED_PATH}}class BotService extends WebFoundationService{dispatch(e,t){console.log("dispatch",t)}}class Random{static generateRandomNumber(e){const t=Math.pow(10,e-1),r=Math.pow(10,e);return Math.floor(Math.random()*(r-t)+t)}static generateRandomToken(e){const t=[],r=this.POOL,i=this.MAX;for(let o=0;o<e;o++){const e=Math.floor(Math.random()*i);t.push(r[e])}return t.join("")}}Random.POOL="2346789BbCcDdFfGgHhJjKkMmPpQqRrTtVvWwXxYy",Random.MAX=Random.POOL.length;class MessageIdentity extends WebFoundationRequestIdentity{}class TelegramMessageIdentity extends MessageIdentity{static[_](e,[t]){let r=`${t.first_name}`;t.last_name&&(r+=` ${t.last_name}`);const i={uid:t.id,providerId:"3fdeba596a7d938a05c38daf"},o=n(i).toHexString(),s=new TelegramMessageIdentity;return s.id=t.id,s.address=IdentityHelper.createIdentityAddress(e)+"/tg/"+t.id,s.user=o,s.profile={_id:o,id:t.username,displayName:r,displayImageURL:""},t.is_bot&&(s.profile.bot=t.is_bot),s.theme=s.theme||e.settings.THEME,s.locale=t.language_code||e.settings.LOCALE,s.timezone=s.timezone||e.settings.TIMEZONE,s}}let ce=class TelegramBotController extends WebFoundationController{async telegram(e){if(!e.params.token)throw new d("Missing bot token for telegram");if(e.settings.TELEGRAM_BOT_TOKEN!=e.params.token)throw new d("Invalid bot token");const t=await e.json(),r=t.channelData||t,i=await e.resolve(TelegramMessageIdentity,function(e){const t=e.message||e.callback_query||e.edited_message||e.pre_checkout_query;let r;if(t)r=t.from;else{const t=Object.keys(e),i=t.find(t=>!!e[t].from);if(!i)throw new d(`Unable to find 'from' field in message: ${t}`);r=e[i].from}return[r,t,e]}(r));let o,n,s,a;if(r.message)n=(o=r.message).chat,a=o.text,s=new Date(1e3*o.date);else if(r.callback_query)n=(o=r.callback_query.message).chat,a=r.callback_query.data,s=new Date(1e3*o.date);else{if(!r.pre_checkout_query)return r.edited_message?(this.logger.debug({sourceEvent:r},"Edit message is ignored in this version"),void(e.body=null)):(this.logger.error({sourceEvent:r},"Unknown message type"),void(e.body=null));{const e=r.pre_checkout_query.from;n={id:e.id,first_name:e.first_name,last_name:e.last_name,username:e.username,type:"private"},a=r.pre_checkout_query.invoice_payload,s=new Date}}const p={id:Random.generateRandomToken(10),type:"message",identity:i,timestamp:s,from:{id:i.id,name:i.profile.displayName},conversation:{isGroup:"private"!==n.type,id:n.id},recipient:{id:e.settings.TELEGRAM_BOT_ID,name:e.settings.NAME},channelId:"telegram",channelData:r,text:a};this.bot.dispatch(e,p)}};se([O(),ae("design:type",BotService)],ce.prototype,"bot",void 0),se([I("POST","/update/:token"),ae("design:type",Function),ae("design:paramtypes",[Object]),ae("design:returntype",Promise)],ce.prototype,"telegram",null),ce=se([b("/api/integration/telegram/bot")],ce);class SessionService extends WebFoundationService{async CreateSession(e,t){if(e.identity.session)throw new Error("SessionAlreadyExists");const r=SessionService.CreateNewSessionId(e),i=SessionService.CreateNewTokenId(e),o=Object.assign({},t,{session:r,token:i});return SessionHelper.save(e,o),Promise.resolve(o)}async ValidateSession(e){return!!(e.identity&&e.identity.token&&t.isValid(e.identity.token))&&!r(new t(e.identity.token))}async UpdateSession(e,t,r){return e.identity.session===t&&(SessionHelper.save(e,Object.assign({},e.identity,r,{session:e.identity.session,token:SessionService.CreateNewTokenId(e)})),!0)}async ExtendSession(e,t){return this.UpdateSession(e,t,{})}async TerminateSession(e,t,r){if(e.identity.session===t){SessionHelper.clear(e);for(const t of Object.keys(e.identity))"id"!==t&&"address"!==t&&delete e.identity[t];return!0}return!1}static CreateNewSessionId(e){return(new t).toHexString()}static CreateNewTokenId(e){const r=new Date(Date.now()+e.settings.WEB_SESSION_EXPIRES_IN_MILLISECONDS);return new t(r).toHexString()}}let le=class FileModel extends Y{};se([G(),ae("design:type",String)],le.prototype,"type",void 0),se([G(),ae("design:type",Number)],le.prototype,"byteLength",void 0),se([G(),ae("design:type",Buffer)],le.prototype,"data",void 0),se([G(),ae("design:type",Buffer)],le.prototype,"md5",void 0),se([G(),ae("design:type",Buffer)],le.prototype,"sha1",void 0),se([G(),ae("design:type",Buffer)],le.prototype,"sha256",void 0),se([G(),ae("design:type",String)],le.prototype,"ipfs",void 0),se([G(),ae("design:type",Number)],le.prototype,"width",void 0),se([G(),ae("design:type",Number)],le.prototype,"height",void 0),se([G(),ae("design:type",Number)],le.prototype,"duration",void 0),le=se([K("file")],le);class FileCollection extends X{constructor(){super(le)}}let ue=class FileTokenModel extends Y{};se([G(),ae("design:type",String)],ue.prototype,"file",void 0),se([G(),ae("design:type",String)],ue.prototype,"type",void 0),se([G(),ae("design:type",Number)],ue.prototype,"byteLength",void 0),se([G(),ae("design:type",String)],ue.prototype,"title",void 0),se([G(),ae("design:type",String)],ue.prototype,"originalname",void 0),se([G(),ae("design:type",String)],ue.prototype,"originalurl",void 0),ue=se([K("file_token")],ue);class FileTokenCollection extends J{constructor(){super(ue)}}class WebFileService{async findTokenById(e,t){return(await e.resolve(FileTokenCollection)).get(t)}async findFileById(e,t){return(await e.resolve(FileCollection)).get(t)}async updateOne(e,t,r){return(await e.resolve(FileTokenCollection)).merge(t,{title:r.title})}async insertFromURL(e,t,r){const i=await function(e){return H(e).then(async e=>({data:await e.buffer(),dataType:e.headers.get("content-type")||"application/octet-stream",dataLength:parseInt(e.headers.get("content-length")||"0")}))}(t),o=t.split("/"),n=o[o.length-1];return this.insertFromBuffer(e,i.data,Object.assign({},r,{originalname:n,originalurl:t,type:i.dataType}))}async insertFromStream(e,t,r){const i=await w(t);return this.insertFromBuffer(e,i,r)}async insertFromBuffer(e,r,i){let{type:o}=i;const n=$("sha256").update(r).digest(),a=require("multihashes").encode(n,"sha2-256"),d=s.fromBuffer(a),p=await e.resolve(FileCollection),c=await e.resolve(FileTokenCollection),l=await p.get(d),u=(new t).toString();if(l){o=l.type;const e={file:d,type:l.type,byteLength:l.byteLength};i&&(e.title=i.title,e.originalname=i.originalname,e.originalurl=i.originalurl),await c.add(u,e)}else{o=o||"application/octet-stream";const t=await e.resolve(FileCollection),n={type:o,byteLength:r.byteLength,data:r};if(i&&(n.width=i.width,n.height=i.height,n.duration=i.duration,n.ipfs=i.ipfs),!await t.add(d,n))throw new Error("UnableToSaveDataChunk");const s={file:d,type:o,byteLength:r.byteLength};i&&(s.title=i.title,s.originalname=i.originalname,s.originalurl=i.originalurl),await c.add(u,s)}return Object.assign({id:u,type:o,byteLength:r.byteLength,url:"/api/file/token/"+u},i)}}export{BotService,ExternalProviderService,ExternalUserService,MultipartWebForm,z as RequestLogMiddleware,V as RequestNormalizerMiddleware,Z as RequestNotFoundMiddleware,Q as RequestRouteMiddleware,ie as RequestStaticMiddleware,SessionService,ce as TelegramBotController,WebFileService,WebFoundationApplication,WebFoundationApplicationIdentity,WebFoundationRequestIdentity,WebFoundationSettings};
//# sourceMappingURL=index.mjs.map
